/*
    Copyright (c) 1997 Netscape Communications Corporation, Inc. All Rights Reserved.

    This software is the confidential and proprietary information of Netscape
    Communications Corporation.  ("Confidential Information").  You shall not
    disclose such Confidential Information and shall use it only in
    accordance with the terms of the agreement you entered into with Netscape.

    Netscape makes no representations or warranties about the suitability of
    this software.  Netscape will not be liable for any damages related to using,
    modifying or distributing this software or derivatives thereof.

    This software is provided for example purposes only.

    created: 2/97 kds
 */

package netscape.peas;

import netscape.palomar.util.*;

public class CSCException extends CascadedException {

    public static final int TABLE_TAG  = 3301;
    public static final int HEADER_ROW = 3302;
    public static final int DATA_ROWS  = 3303;
//    public static final int RESULT_TABLE_TAG = 3304;
//    public static final int RESULT_TABLE_TAG = 3305;
//    public static final int RESULT_TABLE_TAG = 3306;
//    public static final int RESULT_TABLE_TAG = 3307;
//    public static final int RESULT_TABLE_TAG = 3308;
//    public static final int RESULT_TABLE_TAG = 3309;

    public CSCException(int id) {
         super(id);
    }
    public CSCException(int id, Exception e) {
        super(id,e);
    }

    protected String lookup(int id)
    {
        switch (id)
        {
        case TABLE_TAG: return "Missing TABLE tag in retrieved page $url";
        case HEADER_ROW: return "Table does not have a header row ($url)";
        case DATA_ROWS: return "Table does not have any data rows ($url)";
        default: return "identifer "+id+" not in lookup table!";
        }
    }
}