/*
    Copyright (c) 1997 Netscape Communications Corporation, Inc. All Rights Reserved.

    This software is the confidential and proprietary information of Netscape
    Communications Corporation.  ("Confidential Information").  You shall not
    disclose such Confidential Information and shall use it only in
    accordance with the terms of the agreement you entered into with Netscape.

    Netscape makes no representations or warranties about the suitability of
    this software.  Netscape will not be liable for any damages related to using,
    modifying or distributing this software or derivatives thereof.

    This software is provided for example purposes only.

    created: 2/97 cls
 */

package netscape.peas;




/**
 * The Notify event is used to prevent cycles and undue proliferation of events.
 * We derive our events from this class, so that the NotifyList interface is implemented.
 * NOTE: When the JDK implements this we will use that implementation.
 */
public class NotifyEvent implements NotifyList {

    /**
     * default constructor
     */
    NotifyEvent() {
    }

    //----------------------------------------------------
    // NotifyList interface

    /**
     * Add the given object to this list.
     */
    public void addToVisitedList( Object o ) {
        if ( null == moNotifyList ) {
            moNotifyList = new NotifyListSupport();
        }
        moNotifyList.addToVisitedList( o );
    }

    /**
     * Return true if the given object is on this list.
     */
    public  boolean isOnVisitedList( Object o ) {
        if ( null == moNotifyList ) {
            return false;
        } else {
            return moNotifyList.isOnVisitedList( o );
        }
    }

    //--------------------------------------------------------
    // accessors

    public NotifyList getNotifyList() {
        return moNotifyList;
    }

    public void setNotifyList( NotifyList oNotify ) {
        moNotifyList = oNotify;
    }


    //----------------------------------------------------------------
    // member variables

    private NotifyList moNotifyList = null;


} // NotifyEvent