/*
    Copyright (c) 1997 Netscape Communications Corporation, Inc. All Rights Reserved.

    This software is the confidential and proprietary information of Netscape
    Communications Corporation.  ("Confidential Information").  You shall not
    disclose such Confidential Information and shall use it only in
    accordance with the terms of the agreement you entered into with Netscape.

    Netscape makes no representations or warranties about the suitability of
    this software.  Netscape will not be liable for any damages related to using,
    modifying or distributing this software or derivatives thereof.

    This software is provided for example purposes only.

    created: 2/97 cls
 */

package netscape.peas;


import java.beans.PropertyChangeListener;

// cursor info needed by clients of both CursorDataProvider, and CursorDataReceiver
public interface RowProvider {

	/**
	 * Return the number of columns.  This is the "getter" method
	 * for the "numColumns" property.
	 */
	public int getNumColumns();

    /**
     * Return an array of column names.
     */
    public String[] getColumnNames();

    /**
     * Given a column's index (0..NumColumns), return its name
     */
    public String getColumnName( int iColumnNumber );

    /**
     * Return an array of column widths
     */
    public int[] getColumnWidths();

    /**
     * Given a column name, get its value.  This is a
     * "Dynamic-getter" method.  Unlike "normal" setter
     * methods ("void getFoo();"), dynamic-getters can be used
     * for properties whose names are known at compile time.
     */
	public Object getValueByName( String sColumnName );

    /**
     * Another flavor of "Dynamic-getter" method.
     * See @getValueByName.
     */
	public Object getValueByNumber( int iColumnNumber );

    /**
     * Row data providers implement addPropertyChangeListener and publish
     * it in the beaninfo as their OnPropertyChange "add listner" method.
     *
     * Technically, it does not need to be a member of this interface, but
     * hey, why not?
     */
    public void addPropertyChangeListener( PropertyChangeListener x );

    public void removePropertyChangeListener( PropertyChangeListener x );

    public void firePropertyChange( String propertyName, Object oldValue, Object newValue );


    public void addRowChangeListener( RowChangeListener oRowReceiver );

    public void removeRowChangeListener( RowChangeListener oRowReceiver );

    public void fireRowChange( int iChangeType, String sColumnAffected, Object oOldValue, Object oNewValue, RowProvider oRowProvider, NotifyList oNotify );




    public Object[] getColumnValues();
}