/*
    Copyright (c) 1997 Netscape Communications Corporation, Inc. All Rights Reserved.

    This software is the confidential and proprietary information of Netscape
    Communications Corporation.  ("Confidential Information").  You shall not
    disclose such Confidential Information and shall use it only in
    accordance with the terms of the agreement you entered into with Netscape.

    Netscape makes no representations or warranties about the suitability of
    this software.  Netscape will not be liable for any damages related to using,
    modifying or distributing this software or derivatives thereof.

    This software is provided for example purposes only.

    created: 2/97 cls
 */

package netscape.peas;



//import java.beans.PropertyChangeEvent;


/**
 * The RowReceiver receiver interface is implemented
 * by objects which support the receiving of a "record" of data
 * data is received through individual calls to oNCurrentRowsColumnChanged.
 *
 * One of the two objects is considered the "server" in the relationship.
 * The "server" is responsible for defining column names, which is done
 * with a call to initializeColumnNames on or after the registration of
 * this interface as the listner interface for the "server"'s property
 * change event.
 *
 */
public interface RowReceiver extends RowChangeListener {




    /**
     * Given a column's name, set its value to be this new value.
     * This is a "dymanic-setter". See @RowReceiver.getValueByName
     */
    public void setValueByName( String sColumnName, Object oNewValue, NotifyList oNotify );

    /**
     * Different flavor "dynamic-setter".  See @setValueByName.
     */
    public void setValueByNumber( int iColumnNumber, Object oNewValue, NotifyList oNotify );

    /**
     * This method can be called by the data provider to
     * inform us (the client) of its column names
     */
    public boolean initializeColumnInfo( RowProvider oRowProvider );

}