/*
    Copyright (c) 1997 Netscape Communications Corporation, Inc. All Rights Reserved.

    This software is the confidential and proprietary information of Netscape
    Communications Corporation.  ("Confidential Information").  You shall not
    disclose such Confidential Information and shall use it only in
    accordance with the terms of the agreement you entered into with Netscape.

    Netscape makes no representations or warranties about the suitability of
    this software.  Netscape will not be liable for any damages related to using,
    modifying or distributing this software or derivatives thereof.

    This software is provided for example purposes only.

    created: 2/97 cls
 */

package netscape.peas;




/**
 * Methods which allow a client to receive data from this cursor.
 *
 * to do: add/removeCursorChangeListner methods, etc.
 */
public interface TableProvider extends RowProvider  {

    public Table getTable();

    /**
     */
    public RowProvider getCurrentRowValues();

    /**
     * Getter method for "NumRowsFetched" property.  This
     * is the total number of rows satisfying the query if
     * and only if the "rowsPending" property is true.
     */
	public int getNumRowsFetched();


    /**
     * Add oListener a listener of TableChange events
     */
    public void addTableChangeListener( TableChangeListener oListener );

    /**
     * remove oListener as a listener of TableChange events
     */
    public void removeTableChangeListener( TableChangeListener oListener );

    /**
     * helper to fire table chanbe events
     */
    public void fireTableChange( int iChangeType, int iRowAffected, int iColumnAffected, Object oNewValue, TableProvider oTableProvider, NotifyList oNotify );

    /**
     * Return (without changing the "current row"), the values of this tables row # iRowNumer
     */
    public Object[] getNonCurrentRowValues( int iRowNumber );
    
    
    /**
     * Update (to underlying database) this table's current row
     */
    public void updateCurrentRow();
    
    
    /**
     * Helper to perform actual database update.  This, or updateCurrentRow can be overridden
     * to actually sen data to the database.
     */
    public void doUpdateRow( Object[] aColumnNames, Object[] aNewValues, Object[] aOldValues );
 
    
    /**
     * Return true if current row has been changed
     */
    public boolean isCurrentRowChanged();

        

} // TableProvider